// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import fs from 'fs';
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { inspect } from 'util';
import { captureException, getCurrentScope } from '@sentry/nextjs';

import { cors } from '../cors';

export default async function CRMRequestGet({ req, res, path, params, data = undefined, log = false, headers = {}, options = {} }) 
{
	await cors(req, res);

	if(req.headers.cookie !== undefined)
	{
		console.debug("CRMRequestGet", "REQUEST", path);
		const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");

		//console.log("-".repeat(50));
		//console.log("CRMRequestGet", "req.body");
		//console.log(req.body);

		if(cookies.jwt !== undefined && cookies.jwt !== null)
		{
			//console.log("cookies.jwt");
			//console.log(cookies.jwt);

			var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
			var crm_jwt = jwt.sign({ acc_number: client_jwt_decoded.acc_number }, process.env.JWT_SECRET_CRM, { noTimestamp: true });

			if(log)
			{
				console.log("client_jwt_decoded", client_jwt_decoded);
				console.log("crm_jwt", crm_jwt);
			}

			//console.log("path", path);
			//console.log("params", { ...client_jwt_decoded, ...params });

			const payload = { ...{ acc_number: client_jwt_decoded.acc_number }, ...params };
			const request_options = {
				headers: { ...{ "Authorization": `Bearer ${ crm_jwt }` }, ...headers }, 
				withCredentials: true, 
			};

			if(data !== undefined)
			{
				request_options.data = data;
			}
			else
			{
				request_options.params = payload; 
			}	

			try
			{
				console.log({ options, __dirname });
				console.log("{ ...request_options, ...options }", { ...request_options, ...options });

				await axios.get(path, { ...request_options, ...options })
				.then((crm_response) => 
				{
					if(log)
					{
						console.log("crm_response for", path);
						console.log("payload", payload);
						console.log(inspect(crm_response.data, true, null, true));
					}

					res.status(200).json(crm_response.data);
				})
				.catch((error) => 
				{
					const scope = getCurrentScope();
					scope.setExtras({
						path, params, data
					});
					scope.setTag("account", `${ client_jwt_decoded.acc_number }`);
					scope.setTag("offstage", `${ client_jwt_decoded.observer ? true : false }`);
					scope.setUser({ email: client_jwt_decoded.login.indexOf("@") > -1 ? client_jwt_decoded.login : null, phone: client_jwt_decoded.login.indexOf("@") < 0 ? client_jwt_decoded.login : null });
					captureException(error);

					if(log)
					{
						console.error(error);
						console.error("-".repeat(30), "error.response.data:");
						console.error(error.response.data);
					}

					res.status(500).json(error.response.data);
				});
			}
			catch(e)
			{
				console.error(e);
				res.status(500).send(e);
			}
		}
		else
		{
			res.status(403);
		}
	}
}